diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -5338,25 +5294,25 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
         case 2:
             switch (sel) {
             case 1:
-                tcg_gen_helper_0_1(do_mttc0_tcstatus, t0);
+                gen_helper_mttc0_tcstatus(t0);
                 break;
             case 2:
-                tcg_gen_helper_0_1(do_mttc0_tcbind, t0);
+                gen_helper_mttc0_tcbind(t0);
                 break;
             case 3:
-                tcg_gen_helper_0_1(do_mttc0_tcrestart, t0);
+                gen_helper_mttc0_tcrestart(t0);
                 break;
             case 4:
-                tcg_gen_helper_0_1(do_mttc0_tchalt, t0);
+                gen_helper_mttc0_tchalt(t0);
                 break;
             case 5:
-                tcg_gen_helper_0_1(do_mttc0_tccontext, t0);
+                gen_helper_mttc0_tccontext(t0);
                 break;
             case 6:
-                tcg_gen_helper_0_1(do_mttc0_tcschedule, t0);
+                gen_helper_mttc0_tcschedule(t0);
                 break;
             case 7:
-                tcg_gen_helper_0_1(do_mttc0_tcschefback, t0);
+                gen_helper_mttc0_tcschefback(t0);
                 break;
             default:
                 gen_mtc0(env, ctx, t0, rd, sel);
@@ -5366,7 +5322,7 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
         case 10:
             switch (sel) {
             case 0:
-                tcg_gen_helper_0_1(do_mttc0_entryhi, t0);
+                gen_helper_mttc0_entryhi(t0);
                 break;
             default:
                 gen_mtc0(env, ctx, t0, rd, sel);
@@ -5375,7 +5331,7 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
         case 12:
             switch (sel) {
             case 0:
-                tcg_gen_helper_0_1(do_mttc0_status, t0);
+                gen_helper_mttc0_status(t0);
                 break;
             default:
                 gen_mtc0(env, ctx, t0, rd, sel);
@@ -5384,7 +5340,7 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
         case 23:
             switch (sel) {
             case 0:
-                tcg_gen_helper_0_1(do_mttc0_debug, t0);
+                gen_helper_mttc0_debug(t0);
                 break;
             default:
                 gen_mtc0(env, ctx, t0, rd, sel);
@@ -5397,49 +5353,49 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
     } else switch (sel) {
     /* GPR registers. */
     case 0:
-        tcg_gen_helper_0_1i(do_mttgpr, t0, rd);
+        gen_helper_1i(mttgpr, t0, rd);
         break;
     /* Auxiliary CPU registers */
     case 1:
         switch (rd) {
         case 0:
-            tcg_gen_helper_0_1i(do_mttlo, t0, 0);
+            gen_helper_1i(mttlo, t0, 0);
             break;
         case 1:
-            tcg_gen_helper_0_1i(do_mtthi, t0, 0);
+            gen_helper_1i(mtthi, t0, 0);
             break;
         case 2:
-            tcg_gen_helper_0_1i(do_mttacx, t0, 0);
+            gen_helper_1i(mttacx, t0, 0);
             break;
         case 4:
-            tcg_gen_helper_0_1i(do_mttlo, t0, 1);
+            gen_helper_1i(mttlo, t0, 1);
             break;
         case 5:
-            tcg_gen_helper_0_1i(do_mtthi, t0, 1);
+            gen_helper_1i(mtthi, t0, 1);
             break;
         case 6:
-            tcg_gen_helper_0_1i(do_mttacx, t0, 1);
+            gen_helper_1i(mttacx, t0, 1);
             break;
         case 8:
-            tcg_gen_helper_0_1i(do_mttlo, t0, 2);
+            gen_helper_1i(mttlo, t0, 2);
             break;
         case 9:
-            tcg_gen_helper_0_1i(do_mtthi, t0, 2);
+            gen_helper_1i(mtthi, t0, 2);
             break;
         case 10:
-            tcg_gen_helper_0_1i(do_mttacx, t0, 2);
+            gen_helper_1i(mttacx, t0, 2);
             break;
         case 12:
-            tcg_gen_helper_0_1i(do_mttlo, t0, 3);
+            gen_helper_1i(mttlo, t0, 3);
             break;
         case 13:
-            tcg_gen_helper_0_1i(do_mtthi, t0, 3);
+            gen_helper_1i(mtthi, t0, 3);
             break;
         case 14:
-            tcg_gen_helper_0_1i(do_mttacx, t0, 3);
+            gen_helper_1i(mttacx, t0, 3);
             break;
         case 16:
-            tcg_gen_helper_0_1(do_mttdsp, t0);
+            gen_helper_mttdsp(t0);
             break;
         default:
             goto die;
@@ -5449,22 +5405,22 @@ static void gen_mttr(CPUState *env, DisasContext *ctx, int rd, int rt,
     case 2:
         /* XXX: For now we support only a single FPU context. */
         if (h == 0) {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             tcg_gen_trunc_tl_i32(fp0, t0);
             gen_store_fpr32(fp0, rd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         } else {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             tcg_gen_trunc_tl_i32(fp0, t0);
             gen_store_fpr32h(fp0, rd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         break;
     case 3:
         /* XXX: For now we support only a single FPU context. */
-        tcg_gen_helper_0_1i(do_ctc1, t0, rd);
+        gen_helper_1i(ctc1, t0, rd);
         break;
     /* COP2: Not implemented. */
     case 4:
@@ -5504,7 +5460,7 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
             return;
         }
         {
-            TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+            TCGv t0 = tcg_temp_local_new();
 
             gen_mfc0(env, ctx, t0, rd, ctx->opcode & 0x7);
             gen_store_gpr(t0, rt);
@@ -5514,7 +5470,7 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
         break;
     case OPC_MTC0:
         {
-            TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+            TCGv t0 = tcg_temp_local_new();
 
             gen_load_gpr(t0, rt);
             save_cpu_state(ctx, 1);
@@ -5531,7 +5487,7 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
             return;
         }
         {
-            TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+            TCGv t0 = tcg_temp_local_new();
 
             gen_dmfc0(env, ctx, t0, rd, ctx->opcode & 0x7);
             gen_store_gpr(t0, rt);
@@ -5542,7 +5498,7 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
     case OPC_DMTC0:
         check_insn(env, ctx, ISA_MIPS3);
         {
-            TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+            TCGv t0 = tcg_temp_local_new();
 
             gen_load_gpr(t0, rt);
             save_cpu_state(ctx, 1);
@@ -5572,31 +5528,31 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
         opn = "tlbwi";
         if (!env->tlb->do_tlbwi)
             goto die;
-        tcg_gen_helper_0_0(env->tlb->do_tlbwi);
+        gen_helper_tlbwi();
         break;
     case OPC_TLBWR:
         opn = "tlbwr";
         if (!env->tlb->do_tlbwr)
             goto die;
-        tcg_gen_helper_0_0(env->tlb->do_tlbwr);
+        gen_helper_tlbwr();
         break;
     case OPC_TLBP:
         opn = "tlbp";
         if (!env->tlb->do_tlbp)
             goto die;
-        tcg_gen_helper_0_0(env->tlb->do_tlbp);
+        gen_helper_tlbp();
         break;
     case OPC_TLBR:
         opn = "tlbr";
         if (!env->tlb->do_tlbr)
             goto die;
-        tcg_gen_helper_0_0(env->tlb->do_tlbr);
+        gen_helper_tlbr();
         break;
     case OPC_ERET:
         opn = "eret";
         check_insn(env, ctx, ISA_MIPS2);
         save_cpu_state(ctx, 1);
-        tcg_gen_helper_0_0(do_eret);
+        gen_helper_eret();
         ctx->bstate = BS_EXCP;
         break;
     case OPC_DERET:
@@ -5607,7 +5563,7 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
             generate_exception(ctx, EXCP_RI);
         } else {
             save_cpu_state(ctx, 1);
-            tcg_gen_helper_0_0(do_deret);
+            gen_helper_deret();
             ctx->bstate = BS_EXCP;
         }
         break;
@@ -5618,7 +5574,7 @@ static void gen_cp0 (CPUState *env, DisasContext *ctx, uint32_t opc, int rt, int
         ctx->pc += 4;
         save_cpu_state(ctx, 1);
         ctx->pc -= 4;
-        tcg_gen_helper_0_0(do_wait);
+        gen_helper_wait();
         ctx->bstate = BS_EXCP;
         break;
     default:
@@ -5637,7 +5593,7 @@ static void gen_compute_branch1 (CPUState *env, DisasContext *ctx, uint32_t op,
 {
     target_ulong btarget;
     const char *opn = "cp1 cond branch";
-    TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
+    TCGv_i32 t0 = tcg_temp_new_i32();
 
     if (cc != 0)
         check_insn(env, ctx, ISA_MIPS4 | ISA_MIPS32);
@@ -5787,7 +5743,7 @@ static void gen_compute_branch1 (CPUState *env, DisasContext *ctx, uint32_t op,
     ctx->btarget = btarget;
 
  out:
-    tcg_temp_free(t0);
+    tcg_temp_free_i32(t0);
 }
 
 /* Coprocessor 1 (FPU) */
@@ -5797,16 +5753,16 @@ static void gen_compute_branch1 (CPUState *env, DisasContext *ctx, uint32_t op,
 static void gen_cp1 (DisasContext *ctx, uint32_t opc, int rt, int fs)
 {
     const char *opn = "cp1 move";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     switch (opc) {
     case OPC_MFC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             tcg_gen_ext_i32_tl(t0, fp0);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
 	}
         gen_store_gpr(t0, rt);
         opn = "mfc1";
@@ -5814,31 +5770,31 @@ static void gen_cp1 (DisasContext *ctx, uint32_t opc, int rt, int fs)
     case OPC_MTC1:
         gen_load_gpr(t0, rt);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             tcg_gen_trunc_tl_i32(fp0, t0);
             gen_store_fpr32(fp0, fs);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
 	}
         opn = "mtc1";
         break;
     case OPC_CFC1:
-        tcg_gen_helper_1_i(do_cfc1, t0, fs);
+        gen_helper_1i(cfc1, t0, fs);
         gen_store_gpr(t0, rt);
         opn = "cfc1";
         break;
     case OPC_CTC1:
         gen_load_gpr(t0, rt);
-        tcg_gen_helper_0_1i(do_ctc1, t0, fs);
+        gen_helper_1i(ctc1, t0, fs);
         opn = "ctc1";
         break;
     case OPC_DMFC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_mov_tl(t0, fp0);
-            tcg_temp_free(fp0);
+            tcg_gen_trunc_i64_tl(t0, fp0);
+            tcg_temp_free_i64(fp0);
 	}
         gen_store_gpr(t0, rt);
         opn = "dmfc1";
@@ -5846,21 +5802,21 @@ static void gen_cp1 (DisasContext *ctx, uint32_t opc, int rt, int fs)
     case OPC_DMTC1:
         gen_load_gpr(t0, rt);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
-            tcg_gen_mov_tl(fp0, t0);
+            tcg_gen_extu_tl_i64(fp0, t0);
             gen_store_fpr64(ctx, fp0, fs);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
 	}
         opn = "dmtc1";
         break;
     case OPC_MFHC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32h(fp0, fs);
             tcg_gen_ext_i32_tl(t0, fp0);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
 	}
         gen_store_gpr(t0, rt);
         opn = "mfhc1";
@@ -5868,11 +5824,11 @@ static void gen_cp1 (DisasContext *ctx, uint32_t opc, int rt, int fs)
     case OPC_MTHC1:
         gen_load_gpr(t0, rt);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             tcg_gen_trunc_tl_i32(fp0, t0);
             gen_store_fpr32h(fp0, fs);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
 	}
         opn = "mthc1";
         break;
@@ -5892,8 +5848,8 @@ static void gen_movci (DisasContext *ctx, int rd, int rs, int cc, int tf)
     int l1 = gen_new_label();
     uint32_t ccbit;
     TCGCond cond;
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv r_tmp = tcg_temp_new(TCG_TYPE_I32);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv_i32 r_tmp = tcg_temp_new_i32();
 
     if (cc)
         ccbit = 1 << (24 + cc);
@@ -5907,6 +5863,7 @@ static void gen_movci (DisasContext *ctx, int rd, int rs, int cc, int tf)
     gen_load_gpr(t0, rd);
     tcg_gen_andi_i32(r_tmp, fpu_fcr31, ccbit);
     tcg_gen_brcondi_i32(cond, r_tmp, 0, l1);
+    tcg_temp_free_i32(r_tmp);
     gen_load_gpr(t0, rs);
     gen_set_label(l1);
     gen_store_gpr(t0, rd);
@@ -5917,8 +5874,8 @@ static inline void gen_movcf_s (int fs, int fd, int cc, int tf)
 {
     uint32_t ccbit;
     int cond;
-    TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I32);
-    TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
+    TCGv_i32 r_tmp1 = tcg_temp_new_i32();
+    TCGv_i32 fp0 = tcg_temp_local_new_i32();
     int l1 = gen_new_label();
 
     if (cc)
@@ -5934,18 +5891,19 @@ static inline void gen_movcf_s (int fs, int fd, int cc, int tf)
     gen_load_fpr32(fp0, fd);
     tcg_gen_andi_i32(r_tmp1, fpu_fcr31, ccbit);
     tcg_gen_brcondi_i32(cond, r_tmp1, 0, l1);
+    tcg_temp_free_i32(r_tmp1);
     gen_load_fpr32(fp0, fs);
     gen_set_label(l1);
     gen_store_fpr32(fp0, fd);
-    tcg_temp_free(fp0);
+    tcg_temp_free_i32(fp0);
 }
 
 static inline void gen_movcf_d (DisasContext *ctx, int fs, int fd, int cc, int tf)
 {
     uint32_t ccbit;
     int cond;
-    TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I32);
-    TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I64);
+    TCGv_i32 r_tmp1 = tcg_temp_new_i32();
+    TCGv_i64 fp0 = tcg_temp_local_new_i64();
     int l1 = gen_new_label();
 
     if (cc)
@@ -5961,18 +5919,19 @@ static inline void gen_movcf_d (DisasContext *ctx, int fs, int fd, int cc, int t
     gen_load_fpr64(ctx, fp0, fd);
     tcg_gen_andi_i32(r_tmp1, fpu_fcr31, ccbit);
     tcg_gen_brcondi_i32(cond, r_tmp1, 0, l1);
+    tcg_temp_free_i32(r_tmp1);
     gen_load_fpr64(ctx, fp0, fs);
     gen_set_label(l1);
     gen_store_fpr64(ctx, fp0, fd);
-    tcg_temp_free(fp0);
+    tcg_temp_free_i64(fp0);
 }
 
 static inline void gen_movcf_ps (int fs, int fd, int cc, int tf)
 {
     uint32_t ccbit1, ccbit2;
     int cond;
-    TCGv r_tmp1 = tcg_temp_local_new(TCG_TYPE_I32);
-    TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
+    TCGv_i32 r_tmp1 = tcg_temp_new_i32();
+    TCGv_i32 fp0 = tcg_temp_local_new_i32();
     int l1 = gen_new_label();
     int l2 = gen_new_label();
 
@@ -6003,8 +5962,8 @@ static inline void gen_movcf_ps (int fs, int fd, int cc, int tf)
     gen_set_label(l2);
     gen_store_fpr32h(fp0, fd);
 
-    tcg_temp_free(r_tmp1);
-    tcg_temp_free(fp0);
+    tcg_temp_free_i32(r_tmp1);
+    tcg_temp_free_i32(fp0);
 }
 
 
@@ -6054,204 +6013,204 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     switch (ctx->opcode & FOP(0x3f, 0x1f)) {
     case FOP(0, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
-            tcg_gen_helper_1_2(do_float_add_s, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_add_s(fp0, fp0, fp1);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "add.s";
         optype = BINOP;
         break;
     case FOP(1, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
-            tcg_gen_helper_1_2(do_float_sub_s, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_sub_s(fp0, fp0, fp1);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "sub.s";
         optype = BINOP;
         break;
     case FOP(2, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
-            tcg_gen_helper_1_2(do_float_mul_s, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_mul_s(fp0, fp0, fp1);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "mul.s";
         optype = BINOP;
         break;
     case FOP(3, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
-            tcg_gen_helper_1_2(do_float_div_s, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_div_s(fp0, fp0, fp1);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "div.s";
         optype = BINOP;
         break;
     case FOP(4, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_sqrt_s, fp0, fp0);
+            gen_helper_float_sqrt_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "sqrt.s";
         break;
     case FOP(5, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_abs_s, fp0, fp0);
+            gen_helper_float_abs_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "abs.s";
         break;
     case FOP(6, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "mov.s";
         break;
     case FOP(7, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_chs_s, fp0, fp0);
+            gen_helper_float_chs_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "neg.s";
         break;
     case FOP(8, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_roundl_s, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_roundl_s(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "round.l.s";
         break;
     case FOP(9, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_truncl_s, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_truncl_s(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "trunc.l.s";
         break;
     case FOP(10, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_ceill_s, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_ceill_s(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "ceil.l.s";
         break;
     case FOP(11, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_floorl_s, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_floorl_s(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "floor.l.s";
         break;
     case FOP(12, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_roundw_s, fp0, fp0);
+            gen_helper_float_roundw_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "round.w.s";
         break;
     case FOP(13, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_truncw_s, fp0, fp0);
+            gen_helper_float_truncw_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "trunc.w.s";
         break;
     case FOP(14, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_ceilw_s, fp0, fp0);
+            gen_helper_float_ceilw_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "ceil.w.s";
         break;
     case FOP(15, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_floorw_s, fp0, fp0);
+            gen_helper_float_floorw_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "floor.w.s";
         break;
@@ -6262,14 +6221,14 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(18, 16):
         {
             int l1 = gen_new_label();
-            TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
+            TCGv t0 = tcg_temp_new();
+            TCGv_i32 fp0 = tcg_temp_local_new_i32();
 
             gen_load_gpr(t0, ft);
             tcg_gen_brcondi_tl(TCG_COND_NE, t0, 0, l1);
             gen_load_fpr32(fp0, fs);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
             gen_set_label(l1);
             tcg_temp_free(t0);
         }
@@ -6278,14 +6237,14 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(19, 16):
         {
             int l1 = gen_new_label();
-            TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
+            TCGv t0 = tcg_temp_new();
+            TCGv_i32 fp0 = tcg_temp_local_new_i32();
 
             gen_load_gpr(t0, ft);
             tcg_gen_brcondi_tl(TCG_COND_EQ, t0, 0, l1);
             gen_load_fpr32(fp0, fs);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
             gen_set_label(l1);
             tcg_temp_free(t0);
         }
@@ -6294,134 +6253,134 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(21, 16):
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_recip_s, fp0, fp0);
+            gen_helper_float_recip_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "recip.s";
         break;
     case FOP(22, 16):
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_rsqrt_s, fp0, fp0);
+            gen_helper_float_rsqrt_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "rsqrt.s";
         break;
     case FOP(28, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, fd);
-            tcg_gen_helper_1_2(do_float_recip2_s, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_recip2_s(fp0, fp0, fp1);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "recip2.s";
         break;
     case FOP(29, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_recip1_s, fp0, fp0);
+            gen_helper_float_recip1_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "recip1.s";
         break;
     case FOP(30, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_rsqrt1_s, fp0, fp0);
+            gen_helper_float_rsqrt1_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "rsqrt1.s";
         break;
     case FOP(31, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
-            tcg_gen_helper_1_2(do_float_rsqrt2_s, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_rsqrt2_s(fp0, fp0, fp1);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "rsqrt2.s";
         break;
     case FOP(33, 16):
         check_cp1_registers(ctx, fd);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_cvtd_s, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_cvtd_s(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "cvt.d.s";
         break;
     case FOP(36, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvtw_s, fp0, fp0);
+            gen_helper_float_cvtw_s(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "cvt.w.s";
         break;
     case FOP(37, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_cvtl_s, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_cvtl_s(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "cvt.l.s";
         break;
     case FOP(38, 16):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp32_0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp32_1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i64 fp64 = tcg_temp_new_i64();
+            TCGv_i32 fp32_0 = tcg_temp_new_i32();
+            TCGv_i32 fp32_1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp32_0, fs);
             gen_load_fpr32(fp32_1, ft);
             tcg_gen_concat_i32_i64(fp64, fp32_0, fp32_1);
-            tcg_temp_free(fp32_1);
-            tcg_temp_free(fp32_0);
+            tcg_temp_free_i32(fp32_1);
+            tcg_temp_free_i32(fp32_0);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "cvt.ps.s";
         break;
